pro pol,dirm,tit,nfreq,l,xtit,ytit,xmarg,ymarg,nlam1,nlam2,yr

ninc=10

;read in model, skip to largest aperture
readcol,dirm+'/flux.dat',x4,f4,q4,u4,skipline=2*nfreq*ninc+1,$
numline=nfreq*ninc
print,'nfreq*ninc',nfreq*ninc
;read in errors
readcol,dirm+'/flux_err.dat',junk,f4err,q4err,u4err,$
skipline=2*nfreq*ninc+1,numline=nfreq*ninc

a=where(abs(q4err) gt 0.03, count)
if count gt 0 then q4(a)=0.
a=where(abs(u4err) gt 0.03, count)
if count gt 0 then u4(a)=0.


;loadct,10
loadct,0
cmax=240
cmin=10

;nfreq=50
;x4=rebin(x4,ninc*nfreq)
;q4=rebin(q4,ninc*nfreq)

ii=9
plot,(x4(0:nfreq-1)),0.*(q4(nfreq*ii:nfreq*ii+nfreq-1)),$
;/xlog,$
yrange=yr,charthick=2,$
xrange=[0.,20.],$
;xrange=[2,5],$
xstyle=1,ystyle=1,$
ymargin=ymarg,xmargin=xmarg,$
linestyle=0,$
;ytitle='!4k!3F!d!4k!3!n/F',$
ytitle=ytit,$
;linestyle=0,ytitle='!4k!3F!d!4k!3!n (ergs s!u-1!n cm!u-2!n)',$
xtitle=xtit,charsize=1.,thick=5,title=tit,/nodata
for ii=0,8,2 do begin
  ccol=(cmax-cmin)/11*ii+cmin
	print,ccol
  x4plt=x4(0:nlam2-1)
  tmp=q4(nfreq*ii:nfreq*ii+nfreq-1)
  tmp(nlam1:nfreq-1)=smooth(tmp(nlam1:nfreq-1),5)
  ntmp=143
  print,x4plt(ntmp),x4plt(0)
  tmp(0:ntmp)=smooth(tmp(0:ntmp),3)
  q4plt=tmp(0:nlam2-1)
  ;oplot,(x4(0:nfreq-1)),(q4(nfreq*ii:nfreq*ii+nfreq-1))$
  oplot,x4plt,q4plt,color=ccol,thick=2
endfor
oplot,[-100,1000],[0,0],linestyle=1
print,'lambda min plotted',x4plt(nlam2-1)
print,'smoothed by 5 to lambda= ',x4plt(nlam1)


end
