      subroutine envset

c     2005/01/10 (baw) constants for ellipsoidal envelope

      implicit none

      include 'tts.txt'
      include 'opacin.txt'

      real*8 pi,const,sphmass,rd,rdcgs,rmincgs,z1max,r1max,rtmp,r2max

      pi=4.d0*datan(1.d0)

c     outflow boundaries
c     z1max is height where opening angle is measured.  take as outer
c     bound.
      z1max=rmax
      r1max=z1max*dtan(thet1*pi/180.d0)
c     z=a+b*x**beta
c     c1=b
c     z01=a
c     ex1=beta
c     r=x  (r is cylindrical radius)
      c1e=(z1max-z01)/r1max**ex1
      print*,'z1max,z01,r1max,ex1,c1e'
      print*,z1max,z01,r1max,ex1,c1e
c     z01 is input
c     check
      if(z01.lt.0.d0) then
         rtmp=(-z01/c1e)**(1.d0/ex1)
         print*,'hole 1 intersects disk at ',rtmp/autors, ' AU'
      endif
      
      return
      end
