      subroutine initarr

      implicit none

      include 'tts.txt'
      include 'vger.txt'
      include 'grid.txt'

      integer i,j,k,inub,ip,it,ir
	
c     set up angle array
c     dmu=1.d0/(float(nmu)-1.d0)
c     dmuhalf=.5d0*dmu
c     do i=1,nmu
c     u(i)=(float(i)-1.d0)*dmu
c     write(6,*) 'mu',u(i)
c     end do

      dmu=1.d0/float(nmu)
      do i=1,nmu
         u(i)=dmu*(dfloat(i)-0.5d0)
         print*,'mu ',u(i)
      enddo

c     initialize arrays
      do inub=1,nfreq
      do k=1,nmu
         star(inub,k)=0.0d0
      end do
      enddo

      do inub=1,nfreq
         estar(inub)=0.0d0
      enddo

      do inub=1,nfreq
      do k=1,nmu
      do i=1,3
         si(inub,k,i,1)=0.0d0
         si(inub,k,i,2)=0.0d0
         sq(inub,k,i)=0.0d0
         su(inub,k,i)=0.0d0
         sv(inub,k,i)=0.0d0
         si2(inub,k,i)=0.0d0
         sq2(inub,k,i)=0.0d0
         su2(inub,k,i)=0.0d0
         sv2(inub,k,i)=0.0d0
         nums(inub,k,i)=0
         spi(inub,k,i)=0.0d0
         spq(inub,k,i)=0.0d0
         spu(inub,k,i)=0.0d0
         spv(inub,k,i)=0.0d0
      enddo
      enddo
      enddo

      do inub=1,nfreq
      do i=1,3
         ti(inub,i)=0.0d0
         tq(inub,i)=0.0d0
         tu(inub,i)=0.0d0
         tv(inub,i)=0.0d0
         ti2(inub,i)=0.0d0
         tq2(inub,i)=0.0d0
         tu2(inub,i)=0.0d0
         tv2(inub,i)=0.0d0
         numt(inub,i)=0
         tis(inub,i)=0.0d0
         tqs(inub,i)=0.0d0
         tus(inub,i)=0.0d0
         tvs(inub,i)=0.0d0
      end do
      enddo

c      do i=1,nx
c      do j=1,nx
c      do k=1,nmu
c         image(i,j,k)=0.0d0
c         imagei(i,j,k)=0.0d0
c         imageq(i,j,k)=0.0d0
c         imageu(i,j,k)=0.0d0
c         imagev(i,j,k)=0.0d0
c         image2(i,j,k)=0.0d0
c         numi(i,j,k)=0
c      end do
c      end do
c      end do

      do i=1,nxhst
      do j=1,nxhst
      do k=1,nbnd
         tihst(i,j,k)=0.0d0
         tqhst(i,j,k)=0.0d0
         tuhst(i,j,k)=0.0d0
         tvhst(i,j,k)=0.0d0
      end do
      end do
      end do

c     vger stuff is not properly implemented to radeq code
c     but leaving it in
c     for future use when it is implemented.
c     npvg and ncvg are set to 1 for now (vger.txt)
      binpvg=npvg
      bincvg=ncvg
      do i=1,ncvg
         do j=1,npvg
            ivg(i,j)=0.d0
            qvg(i,j)=0.d0
            uvg(i,j)=0.d0
            vvg(i,j)=0.d0
         enddo
      enddo
      ivgflux=0.d0
      qvgflux=0.d0
      uvgflux=0.d0
      vvgflux=0.d0
      ivgerr=0.d0
      qvgerr=0.d0
      uvgerr=0.d0
      vvgerr=0.d0

      do ir=1,nrg
      do it=1,ntg
      do ip=1,npg
         densarr(ir,it,ip)=0.d0
         massarr(ir,it,ip)=0.d0
         tdust(ir,it,ip)=0.d0
         tdust2(ir,it,ip)=0.d0
c     tdust(ir,it,ip)=1000.d0/11605.d0
         nabs(ir,it,ip)=0
         diffdir(ir,it,ip)=0
         dustarr(ir,it,ip)=0
         diffus(ir,it,ip)=.false.
         nodust(ir,it,ip)=.false.
         dtauabs(ir,it,ip)=0.d0
      enddo
      enddo
      enddo

      return
      end


c     ********************************************************
