c     ***********************************************************
      subroutine densenv(rad,rmin,thetin,costin,pi,pihalf,f,phi,dens)

c     calculates density in ellipsoial envelope. called during grid setup
c     so doesn't need to be optimized.

c  history:
c  04/06/2004 (baw): write subroutine, modified from denseta.f

      implicit none
      include 'opacin.txt' 
      real*8 rad,dens,cosa,rado,radi,rmin,phi,thet,thetin,pihalf,y,
     $     pi,r2,costin,m,n,fact,a,z,w,au,f
c     integer a

      au=1.4959787d13

c     for now, assuming +z = -z
      thet=thetin
      cosa=abs(costin)
      if (thet.gt.pihalf) thet=pi-thet

      if (rad.lt.rmaxe.and.rad.gt.rmine) then
	dens=rho2*(rmin/rad)**er1/(1.+f**2*cosa**2)
      else
         dens=0.
      endif

c	TODO, put in bipolar cavity?

       return 
      end

